      SUBROUTINE TRUDGE(RSTART,FUNC,WORK,NR)
      IMPLICIT REAL*8 (A-H,O-Z)
      LOGICAL RSTART
      EXTERNAL FUNC
      DIMENSION WORK(1)
      N1=1
      N2=N1+NR
      N3=N2+NR
      N4=N3+NR
      N5=N4+NR
      N6=N5+NR
      N7=N6+NR
      N8=N7+NR
      N9=N8+NR
      N10=N9+NR**2
      N11=N10+NR**2
      CALL TRUDG(RSTART,FUNC,WORK(N1),WORK(N2),WORK(N3),
     &             WORK(N4),WORK(N5),WORK(N6),WORK(N7),
     &             WORK(N8),WORK(N9),WORK(N10),WORK(N11),NR)
      RETURN
      END

      SUBROUTINE TRUDG(RSTART,FUNC,R,DR,ALPH,RNOT,CURV,SCRAP,P,U,
     &                   V,G,Q,NR)
      IMPLICIT REAL*8 (A-H,O-Z)
      real*4 time
C
C****************************************************
C
C     VERSION 81/07/9/1
C
C****************************************************
C
C     THE MINIMIZATION PACKAGE CONSISTS OF THE SUBROUTINES TRUDGE,
C     SEARCH, TRED2 AND TQL2. SEARCH,TRED2 AND TQL2 ARE AUTOMATICALLY
C     CALLED BY TRUDGE.
C
C     PROGRAM MINIMIZES A FUNCTION OF N VARIABLES F(R(1), ..., R(N))
C     BY A MODIFIED POWELL
C     METHOD OF SEARCH ALONG CONJUGATE DIRECTIONS. COLUMNS OF V MATRIX
C     ARE CURRENT SEARCH DIRECTIONS.COLUMNS 1 TO K ARE (APROXIMATELY)
C     CONJUGATE.
C
C     CALLING:
C     TRUDGE PARAMETER LIST CONTAINS FOUR PARAMETERS.
C     RSTART - SHOULD BE .TRUE. IN CASE OF RESTART
C     FUNC - NAME OF AN EXTERNAL FUNCTION SUPPLIED BY PROGRAMMER
C     WHICH WILL COMPUTE F(R) AND READ AND WRITE DATA.
C     WORK - WORKING AREA OF 8*NR+3*NR**2 SIZE
C     NR - DIMENSION OF LARGEST OPTIMIZATION IN GIVEN PROGRAM
C
C     DATA FOR REGULAR RUN
C
C     IF THE SUBROUTINE IS ENTERED WITH RSTART=.FALSE. IT WILL
C     FIRST CALL FUNC(-1,R,F) TO FILL COMMON EOPT AND INITIALIZE R
C     TOLF - TOLERANCE OF FUNCTION
C     TOLR - TOLERANCE OF ARGUMENT
C     BOTH CONDITIONS HAVE TO BE FULFILLED FOR CONVERGENCE
C     NOISE - CHANGES SMALLER THAN NOISE WILL BE CONSIDERED
C     TO BE MEANINGLESS IN SEARCH
C     TIMLIM - TIME LIMIT
C     LOUT - OUTPUT TAPE FOR RESTART DATE. PROGRAM WILL WRITE
C     THE RESTART DATA ON THIS TAPE. DEFAULT IS 7
C     ALFST - SIZE OF STEP. DEFAULT 0.1
C     IPR - IF .NE. 0 NO PRINT IN A SINGLE STEP OF SEARCH, =2 SHORT RES TAP
C     LINP - THIS PARAMETER IS ONLY FOR RESTART CASE. IT GIVES
C     NUMBER OF TAPE FROM WHICH RESTART DATA WILL BE READ. DEFAULT
C     IS 9.
C     SAFETL - SAFETY TIME LIMIT. EACH SAFETL SECONDS THE RESTART TAPE
C              WILL BE WRITTEN. IN DATA IF SAFETL IS READ LT 0 IT IS
C              SUBSTITUTED BY 1D30, I.E. NO SAFETY WRITINGS TAKES PLACE
C              DURING FIRST 1D23 YEARS CPU TIME. IF SAFETL IS INPUTED AS
C              0 DEFAULT VALUE 1D3 IS USED
C
C     MINIMIZATION PROCESS
C
C     TRUDGE WILL CALL FUNC(0,R,F) SEVERAL TIMES. FUNC(0,R,F) SHOULD COM-
C     PUTE F(R) AND PLACE IT IN COMMON EOPT.
C
C     EXIT FROM PROCEDURE
C
C     IF THE COMPUTATION CONVERGES BEFORE TIME LIMIT IS REACHED
C     TRUDGE WILL CALL FUNC(1,R,F) THEN IT WILL WRITE THE RESTART
C     DATA, CALL FUNC(2,R,F) AND RETURN. THIS IS DEVISED SO TO
C     ENABLE CONTINUATION OF OPTIMIZATION WITH SMALLER THRESHOLDS.
C
C     IF THE TIME LIMIT IS REACHED THE FINAL CALLING SEQUENCE
C     IS THE SAME BUT THE LAST INSTRUCTION IS CALL EXIT.
C     CHECK FOR THE TIME LIMIT IS AFTER EACH SEARCH CALLING EXCEPT
C     FOR THE LAST CALLING IN THE SEQUENCE.
C
C     RESTART DATA
C
C     RESTART DATA ARE THE PARAMETERS DESCRIBING THE PRESENT STATUS
C     OF OPTIMIZATION. THEY ARE WRITTEN AUTOMATICALLY ON TAPE LOUT
C     AS 80 CHARACTERS RECORDS. TAPE LOUT SHOULD BE CATALOGUED OR
C     PUNCHED. IN THE RESTART RUN ALL PARAMETERS WILL BE READ AUTO-
C     ATICALLY.
C
C     SAFETY WRITTING OF RESTART DATA
C
C     EVEN IF TIME LIMIT HAS NOT BEEN REACHED RESTART DATA WILL
C     BE WRITTEN AFTER FINISHING THE SEARCH ALONG THE GIVEN SET
C     OF CONJUGATE DIRECTIONS.
C     TRUDGE CHECKS FOR TIME LIMIT AFTER EACH CALLING OF SEARCH.
C     IF YOUR COMPUTER IS KNOWN TO OFTEN MAKE ERRORS LIKE MODE ERRORS
C     ON CDC IT IS EASY TO CHANGE THE SUBROUTINE IN SUCH A WAY
C     THAT IT WILL WRITE THE RESTART TAPE AFTER EACH CALLING
C     OF SEARCH INDEPENDENTLY OF TIME.
C
C     RESTART
C
C     IF THE CALCULATION IS RESTARTED TRUDGE SHOULD BE ENTERED WITH
C     RESTART=.TRUE. THE PREVIOUSLY WRITTEN TAPE LOUT SHOULD BE
C     ATTACHED AS LINP. TRUDGE WILL FIRST CALL FUNC(-2,R,F). SOME ADDI-
C     TIONAL PARAMETERS WHICH DEFINE F BUT WHICH ARE NOT IN EOPT
C     (IF ANY) SHOULD BE READ. THEN TRUDGE WILL READ PREVIOUSLY
C     WRITTEN RESTART TAPE AND CALL FUNC(-3,R,F) TO ALLOW CHANGES IN
C     DATA.
C     EXTERNAL FUNCTION FUNC(INOUT,R,F)
C     INOUT= -3   FUNCTION INTRODUCES CHANGES TO RESTART DATA
C     INOUT= -2   FUNCTION READS STARTING DATA NOT CONTAINED IN EOPT
C     INOUT= -1   FUNCTION READS MINIMAL STARTING DATA AND EVAL F(R)
C     INOUT=  0   FUNCTION EVALUATES F(R)
C     INOUT=  1   FUNCTION WRITES DATA FOR FUTURE CALL FUNC(1,R,F)
C     INOUT=  2   FUNCTION EVALUATES F(R) AND PRINTS OUTPUT.
C
C
      REAL*8   NOISE
      COMMON/EOPT/TOLF,TOLR,NOISE,TIMLIM,LINP,LOUT,ALFST,IPR,N,
     &            SAFETL
      COMMON/IOPT/CURVE,ALPHA,EXACT,JSTART,FNOT
      DIMENSION R(1),DR(1),ALPH(1),RNOT(1),CURV(1),SCRAP(1),P(1),U(1)
      DIMENSION V(NR,NR),G(NR,NR),Q(NR,NR)
      LOGICAL EXACT, RSTART, CONV
      Common/inou/icon(80)
      EXTERNAL FUNC
c
c ---- Initialize timer for Trudge Routine and icon(1) counter
c
      icon(1) = 0
c      CALL STIME 
      WRTLST=0.d00
      NMAX=NR
      CONV=.FALSE.
 
      IF (.NOT.RSTART) GO TO 15
C
C     RSTART=.TRUE.
C
      CALL FUNC(-2,R,F)
C
C     READS TAPE LINP
C
      READ(LINP,155) N,K,J,F,FNOT,TOLF,TOLR,NOISE,TIMLIM,IPR,
     &               SAFETL
      DO 1 I=1,N
    1 READ(LINP,161) II,R(I),RNOT(I),CURV(I),ALPH(I)
      I1=1
    5 I2=I1+7
      IF(I2.GT.N) I2=N
      DO 6 L=1,N
    6 READ(LINP,168) (V(L,I),I=I1,I2)
      I1=I2+1
      IF(I1.LE.N) GO TO 5
 
      FN=N
      IF(N.GT.NMAX) WRITE(6,999)
      IF(N.GT.NMAX) CALL EXITX
  999 FORMAT(12H N .GT. NMAX)
      if(icon(74).ne.0) then
         CALL FUNC(-3,R,F)
      endif
      GO TO 100
C
C     IF RSTART=.F. SET INITIAL V MATRIX TO IDENTITY,STANDARD VALUES.
C
   15 K=-1
      CALL FUNC(-1,R,F)
      FN=N
      IF(N.GT.NMAX) WRITE(6,999)
      IF(N.GT.NMAX) CALL EXITX
      DO 30 I=1,N
      ALPH(I)=ALFST
      DO 20 J=1,N
   20 V(I,J)=0.0D0
      CURV(I)=0.0D0
   30 V(I,I)=1.0D0
      J=N
C
C     SEARCH ALONG J-TH DIRECTION FOR LOCAL MINIMUM
C
  100 DO 105 I=1,N
  105 DR(I)=V(I,J)
      EXACT=J.LE.K
      ALPHA=ALPH(J)
      ALFSET=ALPHA
      if(ipr.eq.0)write(6,*)'optimizing j =',j
      CALL SEARCH(FUNC,R,DR,SCRAP,F,LEAVE)
      IF(IPR.EQ.0) WRITE(6,120) CURVE,ALPHA
  120 FORMAT(17H  NEW CURVATURE =,E13.5,10H   ALPHA =,F12.7)
  121 FORMAT(17H  OLD CURVATURE =,E13.5,10H   ALFSET=,F12.7)
  122 FORMAT(20X,30H ABNORMAL RETURN FROM SEARCH  )
      ALPHA=ABS(ALPHA)
      IF(ALPHA.LT.0.5D0*ALFSET) ALFSET=0.5D0*ALFSET
      IF(ALPHA.LT..25D0*ALFSET) ALFSET=0.5D0*ALFSET
      IF(ALPHA.GT.2.0D0*ALFSET) ALFSET=2.0D0*ALFSET
      IF(ALPHA.GT.4.0D0*ALFSET) ALFSET=2.0D0*ALFSET
      IF(IPR.EQ.0) WRITE(6,121) CURV(J),ALFSET
      CURV(J)=CURVE
      ALPH(J)=ALFSET
      IF(J.EQ.1) GO TO 175
      J=J-1
      CALL SECOND(TIME)
      If(icon(13).ne.0) write(6,901) TIME 
c restart file will be written after each linear search...
c      IF((TIME-WRTLST) .GT. SAFETL) GO TO 150
      go to 150
      IF(TIME-TIMLIM) 100,150,150
C
C     WRITE RESTART TAPE
C
  150 CONTINUE
      REWIND LOUT
      WRTLST=TIME
      CALL FUNC(1,R,F)
      WRITE(LOUT,155) N,K,J,F,FNOT,TOLF,TOLR,NOISE,TIMLIM,IPR,
     &                SAFETL
  155 FORMAT(3I5,2E25.15/4E10.2,I2,E8.1)
      IF(IPR.EQ.2 .AND. TIME.LT.TIMLIM) GO TO 169
      DO 160 I=1,N
  160 WRITE(LOUT,161)I,R(I),RNOT(I),CURV(I),ALPH(I)
  161 FORMAT(I5,4E18.10)
      I1=1
  165 I2=I1+7
      IF(I2.GT.N) I2=N
      DO 166 L=1,N
  166 WRITE(LOUT,168)(V(L,I),I=I1,I2)
  168 FORMAT(8F10.7)
c endfile added by RB.
      endfile lout
      backspace lout
      I1=I2+1
      IF(I1.LE.N) GO TO 165
C
C     TAPE LOUT HAS BEEN WRITTEN
C
  169 CALL SECOND(TIME)
      IF(.NOT.CONV .AND. TIME .LT. TIMLIM) GO TO 100
      CALL FUNC(2,R,F)
      IF(CONV) RETURN
      CALL EXITX
 
C
C     END OF SEQUENCE OF SEARCH ALONG ALL DIRECTIONS IN V MATRIX.
C
C 175 IF(K .GE. 0) GO TO 185
  175 IF(K. GE. 0  .AND.  K. NE. N) GO TO 185
      DO 180 I=1,N
  180 RNOT(I)=R(I)
      FNOT=F
      K=0
      J=N
      GO TO 100
C
C     GENERATE NEW CONJUGATE DIRECTION IF NOT CONVERGED.
C
  185 DRDR=0.0
      DO 188 I=1,N
      DUM=R(I)-RNOT(I)
      DR(I)=DUM
  188 DRDR=DUM*DUM+DRDR
      ALFSET=SQRT(DRDR)
      ALPHA=ALFSET
      IF(ALPHA.EQ.0.0D0) GO TO 192
      DO 190 I=1,N
      U(I)=DR(I)/ALFSET
  190 DR(I)=U(I)
      EXACT=.TRUE.
      CALL SEARCH(FUNC,R,DR,SCRAP,F,LEAVE)
      IF(LEAVE.NE.0) WRITE(6,122)
C The following line repalced to supress print in SCF optim.
C     WRITE(6,120) CURVE,ALPHA
      if(icon(72).ne.0) WRITE(6,120) CURVE,ALPHA
      ALPHA=ABS(ALPHA)
C
C     THE FOLL 5 LINES HAVE BEEN ADDED BY K.SZALEWICZ
C     WITHOUT THIS SEARCH IS ENTERED WITH ALF=0.0
C
      IF(ALPHA.LT.0.5D0*ALFSET) ALFSET=0.5D0*ALFSET
      IF(ALPHA.LT..25D0*ALFSET) ALFSET=0.5D0*ALFSET
      IF(ALPHA.GT.2.0D0*ALFSET) ALFSET=2.0D0*ALFSET
      IF(ALPHA.GT.4.0D0*ALFSET) ALFSET=2.0D0*ALFSET
      ALPHA=ALFSET
  192 DELF=FNOT-F
      FNOT=F
      DRDR=0.0
      DO 195 I=1,N
      DRDR=(R(I)-RNOT(I))**2+DRDR
  195 RNOT(I)=R(I)
      DELR=SQRT(DRDR/FN)
C The following line replaced to supress print in SCF optim.
      WRITE(6,210) F, DELF, DELR
      if(icon(72).ne.0) WRITE(6,210) F, DELF, DELR
  210 FORMAT(4H  F=,F20.10,10H  DELTA F=,E15.5,10H  DELTA R=,E15.5)
c ENDFILE 6 added by RB
	endfile 6
	backspace 6
c The following 4 lines added by RB on 30 Mar 1992 to enable expand...
	if(icon(73).ne.0) then
	  conv=.true.
	  goto 150
	endif
c
c icon(1) -- used to count cycles
c icon(2) -- max number of cycles allowed
c
      icon(1) = icon(1) + 1
      IF((DELF.GT.TOLF.OR.DELR.GT.TOLR).and.icon(1).lt.icon(2)) 
     1 GO TO 220
      WRITE(6,215)
      CONV=.TRUE.
  215 FORMAT(//,' CONVERGED')
      GO TO 150
  220 IF(K.GT.0) GO TO 230
      K=1
      K1=0
      DO 225 I=1,N
  225 R(I)=DR(I)
      DR(N)=CURVE
      P(1)=ALPHA
      GO TO 375
C
C     CALCULATE K+1 Q VECTORS.Q(I) DOT V(J)=KRONIKER DELTA(I,J),J=1,K
C
  230 DO 250 J=1,K
      DOT=0.0
      DO 240 I=1,N
  240 DOT=DR(I)*V(I,J)+DOT
      P(J)=DOT
      DO 250 I=1,N
  250 DR(I)=DR(I)-DOT*V(I,J)
      DOT=0.0
      DO 260 I=1,N
  260 DOT=DR(I)*U(I)+DOT
      K1=K
      K=K1+1
C     RSTART=K.NE.N
      DO 270 I=1,N
      DUM=DR(I)/DOT
      Q(I,K)=DUM
      DO 270 J=1,K1
  270 Q(I,J)=V(I,J)-P(J)*DUM
C
C     G MATRIX=SUM L=1,K+1 OF Q(L)*CURV(L)*TRANSPOSE Q(L)
C
      DO 280 I=1,N
      DUM=CURVE*Q(I,K)
      DO 280 J=1,N
  280 G(I,J)=DUM*Q(J,K)
      DO 300 L=1,K1
      DO 300 I=1,N
      DUM=CURV(L)*Q(I,L)
      DO 300 J=1,N
  300 G(I,J)=DUM*Q(J,L)+G(I,J)
      CALL TRED2(NMAX,N,G,DR,SCRAP,G)
      CALL TQL2(NMAX,N,DR,SCRAP,G,IERR)
      DO 301 I=1,N
      DO 301 J=1,N
  301 Q(I,J)=G(I,J)
C
C     SET P(J) EQUAL TO CORRESPONDING ALPH VALUE.
C
      DO 350 J=1,K
      JJ=N+1-J
      P(J)=ALPH(J)
      DOT=0.0
      DO 310 I=1,N
      R(I)=Q(I,JJ)
  310 DOT=R(I)*V(I,J)+DOT
      DOT=ABS(DOT)
      IF(DOT.GT.0.7D0) GO TO 350
      LMAX=J
      DOTMAX=DOT
      DO 340 L=1,K1
      IF(L.EQ.J) GO TO 340
      DOT=0.0
      DO 320 I=1,N
  320 DOT=R(I)*V(I,L)+DOT
      DOT=ABS(DOT)
      IF(DOT.LT.0.7D0) GO TO 330
      P(J)=ALPH(L)
      GO TO 350
  330 IF(DOT.LE.DOTMAX) GO TO 340
      DOTMAX=DOT
      LMAX=L
  340 CONTINUE
      P(J)=ALPH(LMAX)
      DOT=0.0
      DO 345 I=1,N
  345 DOT=R(I)*U(I)+DOT
      IF(ABS(DOT).GT.DOTMAX) P(J)=ALPHA
  350 CONTINUE
C
C     SET NEV CONJUGATE VECTORS IN V EXCEPT KTH VECTOR IS SAVED IN R.
C
      DO 370 J=1,K1
      JJ=N+1-J
      DO 360 I=1,N
  360 V(I,J)=Q(I,JJ)
      ALPH(J)=P(J)
  370 CURV(J)=DR(JJ)
C
C     ORTHOGONALIZE REMAINING SEARCH DIRECTIONS TO CONJUGATE DIRECTIONS.
C
  375 IF(K.EQ.N) GO TO 450
      DO 420 J=K,N
      DOT=0.0
      DO 380 I=1,N
  380 DOT=V(I,J)*R(I)+DOT
      DO 390 I=1,N
  390 V(I,J)=V(I,J)-DOT*R(I)
      IF(K.EQ.1) GO TO 420
      DO 410 L=1,K1
      DOT=0.0
      DO 400 I=1,N
  400 DOT=V(I,J)*V(I,L)+DOT
      DO 410 I=1,N
  410 V(I,J)=V(I,J)-DOT*V(I,L)
  420 CONTINUE
      CMAX=0.0
      DO 425 L=K,N
  425 IF(CURV(L).GT.CMAX) CMAX=CURV(L)
C
C     CONSTRUCT G MATRIX FOR REMAINING SEARCH DIRECTIONS.
C
      CMAX=8.0*CMAX
      DO 440 I=1,N
      DO 440 J=1,I
      DUM=-CMAX*R(I)*R(J)
      DO 430 L=K,N
  430 DUM=CURV(L)*V(I,L)*V(J,L)+DUM
      IF(K1.LE.0) GO TO 435
      DO 433 L=1,K1
  433 DUM=-CMAX*V(I,L)*V(J,L)+DUM
  435 G(I,J)=DUM
  440 G(J,I)=DUM
C
C     SET KTH CONJUGATE DIRECTIONS BACK INTO V MATRIX.
C
  450 DO 460 I=1,N
      V(I,K)=R(I)
  460 R(I)=RNOT(I)
      ALPH(K)=P(K)
      CURV(K)=DR(N+1-K)
      IF(K.EQ.N) GO TO 480
      CALL TRED2(NMAX,N,G,DR,SCRAP,G)
      CALL TQL2(NMAX,N,DR,SCRAP,G,IERR)
      DO 461 I=1,N
      DO 461 J=1,N
  461 Q(I,J)=G(I,J)
C
C     SET REMAINING SEARCH DIRECTIONS INTO V MATRIX.
C
      K1=K+1
      DO 470 J=K1,N
      CURV(J)=DR(J)
      DO 470 I=1,N
  470 V(I,J)=Q(I,J)
  480 J=N
      GO TO 150
  901 format(' Time Used by Trudge up to this Point:',f12.2,' Seconds')         
      END
      SUBROUTINE SEARCH(GAUSS,X,DX,XNOT,FUNC,LEAVE)
      IMPLICIT REAL*8 (A-H,O-Z)
C
C
C     SUBROUTINE LOCATES A LOCAL MINIMUM ALONG A GIVEN ONE-DIMENSIONAL
C     SEARCH DIRECTION.
C     F(ALF) = FUNC(X+ALF*DX) FIND OPTIMUM ALF VALUE.
C     LOOKMAX = MAXIMUM NUMBER OF FUNCTION EVALUATIONS BEFORE SEARCH IS
C               TERMINATED
C     ENTER SUBROUTINE WITH FOLLOWING
C     N     = DIMENSIONALITY OF X SPACE
C     X     = INITIAL POSITION (IN N DIMENSIONAL PARAMETER SPACE)
C     FUNC  = F(0) , I.E. FUNCTION VALUE AT INITIAL X.
C     DX    = SEARCH DIRECTIONS(IN N-DIMENSIONAL SPACE)
C     AMIN  = ESTIMATED INITIAL STEP SIZE
C     NOISE = ACCURACY OF FUNC VALUES. VARIATIONS SMALLER THAN NOISE
C             ARE NOT CONSIDERED TO BE SIGNIFICANT.
C     EXACT = .FALSE.  SUPPRESSES FINAL CHECK OF QUADRATIC FIT.
C
C     EXIT FROM SUBROUTINE WITH FOLLOWING
C     X     = CALCULATED MINIMUM
C     FUNC  = F(AMIN) ,I.E. FUNCTION VALUE AT FINAL X.
C     CURVE = CALCULATED CURVATURE ALON SEARCH DIRECTIONS
C     LEAVE = 0 IF NORMAL EXIT
C           = 2 IF EXCESSIV NUMBER OF FUNCTIONS EVALUATIONS
C
C     N,NMAX,FUNC,AND X ARE SHARED WITH SUBROUTINE GAUSS.
C     ALL VARIABLES IN COMMONS ARE SHARED WITH PROGRAM CALLING SEARCH
C
      REAL*8   NOISE
      COMMON/EOPT/TOLF,TOLR,NOISE,TI,LI,LO,AL,IPR,N
      COMMON/IOPT/CURVE,AMIN,EXACT
      DIMENSION X(1),DX(1),XNOT(1),F(9),SET(9)
      EQUIVALENCE (F(1),F1),(F(3),F3),(F(4),F4),(F(5),F5),(F(6),F6),
     1  (F(7),F7),(F(9),F9),(SET(1),SET1),
     2  (SET(2),SET2),(SET(3),SET3),(SET(4),SET4),(SET(5),SET5),
     3  (SET(6),SET6),(SET(7),SET7),(SET(8),SET8),(SET(9),SET9)
      LOGICAL BACK, SET, SET1,SET2,SET3,SET4,SET5,SET6,SET7,SET8,SET9
     1,EXACT,HOLD
      external gauss
      LOOKS=0
      LEAVE=0
      LOOKMX=30
      DO 5 I=1,N
    5 XNOT(I)=X(I)
      ALF=AMIN
      AMIN=0.0
      FNOT = FUNC
      FMIN=FUNC
CNOVAX   1
C     FNEXT=1.0D75
CVAX     1
      FNEXT=1.0D35
      IR=4
   10 LOOKS=LOOKS+1
      IF(LOOKS.LE.LOOKMX) GO TO 20
      LEAVE=2
      WRITE(6,13) LOOKS
   13 FORMAT(/' EXCESSIVE NUMBER OF FUNCTION EVALUATIONS =',I3/)
C
C     RETURN FROM SUBROUTINE
C
   15 DO 16 I=1,N
   16 X(I)=XNOT(I)+AMIN*DX(I)
      FUNC=FMIN
      RETURN
C
C     EVALUATE F(ALF)=FUNC(XNOT+ALF*DX)
C
   20 DO 25 I=1,N
   25 X(I)=XNOT(I)+ALF*DX(I)
      INOUT=0
      CALL GAUSS(INOUT,X,FUNC)
C
C     INOUT = 7 INDICATES PATHOLOGICAL X VALUE FOR GAUSS CALCULATION.
C
      IF(INOUT.EQ.7) GO TO 305
      HOLD=.FALSE.
      IF(FUNC.GE.FMIN) GO TO 28
      FNEXT=FMIN
      FMIN=FUNC
      ANEXT=AMIN
      AMIN=ALF
      GO TO 29
   28 IF(FUNC.GE.FNEXT) GO TO 29
      FNEXT=FUNC
      ANEXT=ALF
c   27 FORMAT(' LOOKS =',I3,' ALF =',F10.5, ' FUNC =',F15.9,/,
c     2 ' AMIN =',
c     1 F10.5,' FMIN =',F15.9,' ANEXT =',F10.5,' FNEXT =',F15.9)
   27 FORMAT(' LOOKS =',I3,' ALF =',F10.5, ' FUNC =',E15.7,/,
     2 ' AMIN =',
     1 F10.5,' FMIN =',E15.7,' ANEXT =',F10.5,' FNEXT =',E15.7)
   29 IF(IPR.EQ.0)
     &WRITE(6,27) LOOKS, ALF, FUNC, AMIN, FMIN, ANEXT, FNEXT
      GO TO (29,29,29,150,180,260,320), IR
C
C     F1,F3,F5,F7,F9, ARE FUNC VALUES AT EVENTLY SPACED POINTS WITH
C     SEPARATION DELTA. SET(I)=TRUE INDICATES THAT F(I) HAS BEEN
C     EVALUATED. DELTA MAY INCREASE OR DECREASE BY FACTORS OF 2. 0.
C     F VALUES SHIFT LEFT OR RIGHT SO THAT F5 IS ALWAYS LOWEST.
C
  150 DELTA=ABS(AMIN-ANEXT)
      BACK=.FALSE.
      DO 155 I=1,9
  155 SET(I)=.FALSE.
      F5=FMIN
      SET5=.TRUE.
      K=3
      IF(AMIN.LT.ANEXT) K=7
      F(K)=FNEXT
      SET(K)=.TRUE.
  160 IF(SET7) GO TO 230
      IF(SET3) GO TO 200
      IF(BACK) GO TO 250
  170 ALF=AMIN+DELTA
      IR=5
      GO TO 10
  180 F7=FUNC
      SET7=.TRUE.
      IF(ALF.NE.AMIN) GO TO 160
C
C     SHIFT LEFT
C
      DO 190 I=1,7
      SET(I)=SET(I+2)
  190 F(I)=F(I+2)
      SET8=.FALSE.
      SET9=.FALSE.
      GO TO 160
  200 IF(.NOT.SET1) GO TO 170
C
C     EXTRAPOLATE USING F1,F3, AND F5
C     ICREASE STEP SIZE IF F9 IS PREDICTED TO BE LOWER THAN F7.
C     DECREASE STEP SIZE IF F4 IS PREDICTED TO BE LOWER THAN F5.
C
  210 BACK=4.0*F3.LT.(F1+3.0*F5)
      IF(SET9.OR.HOLD) GO TO 215
      IF(5.0*F3.GT.(2.0*F1+3.0*F5)) GO TO 220
  215 IF(SET4) GO TO 170
      IF(6.0*F3.GT.(F1+5.0*F5))GO TO 170
      GO TO 305
  220 DELTA=DELTA+DELTA
      F4=F3
      F3=F1
      F6=F7
      F7=F9
      SET4=SET3
      SET3=SET1
      SET6=SET7
      SET7=SET9
      SET1=.FALSE.
      SET2=.FALSE.
      SET8=.FALSE.
      SET9=.FALSE.
      GO TO 160
  230 IF(SET3) GO TO 300
      IF(.NOT.SET9) GO TO 250
C
C     EXTRAPOLATE USING F5, F7, AND F9.
C     INCREASE ISTEP SIZE IF F1 IS PREDICTED TO B LOWER THAN F3
C     DECREASE STEP SIZE IF F6 IS PREDICTED TO BE LOWER THAN F5.
C
  240 BACK=4.0*F7.GT.(F9+3.0*F5)
      IF(SET1.OR.HOLD) GO TO 245
      IF(5.0*F7.GT.(2.0*F9+3.0*F5)) GO TO 220
  245 IF(SET6) GO TO 250
      IF(.NOT.(6.0*F7.GT.(F9+5.0*F5))) GO TO 305
  250 ALF=AMIN-DELTA
      IR=6
      GO TO 10
  260 F3=FUNC
      SET3=.TRUE.
      IF(ALF.NE.AMIN) GO TO 160
      DO 270 I=1,7
      SET(10-I)=SET(8-I)
  270 F(10-I)=F(8-I)
      SET1=.FALSE.
      SET2=.FALSE.
      GO TO 160
C
C     INTERPOLATE USING F3, F5, AND F7.
C     EITHER IMMEDIATELY ATTEMPT QUADRATIC FIT OR FIRST REDUCE STEP SIZE
C     IF AMIN=ZERO STEP SIZE  MAY BE REDUCED BY A FACTOR OF 2,4,8,OR 16
C     IN OTHER CASES STEP SIZE IS REDUCED BY A FACTOR OF 2.
C
  300 DUM=F3
      IF(F7.GT.F3) DUM=F7
      SPREAD=DUM-F5
      TOL=(FNOT-FMIN)*0.5D0
      IF(TOL.LT.1000.0*NOISE) TOL=1000.0*NOISE
      IF(.NOT.EXACT) TOL=TOL+TOL
      DUM=F3-F5-F5+F7
      CURVE=DUM/(2.0*DELTA*DELTA)
c exit, if dum=0, i.e., surface too flat (added by RB, 9/25/97)
      if(dabs(dum).lt.1.d-20) then
       write(6,*)'Flat surface',f3,f5,f7
       go to 15
      endif
      DUM=(F3-F7)/DUM
      BACK=DUM.LT.0.0
      IF(SPREAD.LT.TOL) GO TO 310
      IF(ABS(DUM).GT.0.75.OR.AMIN.NE.0.0) GO TO 305
      SET1=SET4
      F1=F4
      SET9=SET6
      F9=F6
      SET2=.FALSE.
      SET3=.FALSE.
      SET4=.FALSE.
      SET6=.FALSE.
      SET7=.FALSE.
      SET8=.FALSE.
      DELTA=0.25D0*DELTA
      IF(ABS(DUM).GT.0.375) GO TO 160
      SET1=.FALSE.
      SET9=.FALSE.
      DELTA=0.5D0*DELTA
      IF(ABS(DUM).GT.0.1875) GO TO 160
      DELTA=0.5D0*DELTA
      GO TO 160
C
C     CUT STEP SIZE IN HALF
C
  305 DELTA=0.5D0*DELTA
      HOLD=.TRUE.
      SET1=SET3
      SET3=SET4
      SET9=SET7
      SET7=SET6
      SET2=.FALSE.
      SET4=.FALSE.
      SET6=.FALSE.
      SET8=.FALSE.
      F1=F3
      F3=F4
      F9=F7
      F7=F6
      GO TO 160
C
C     ATTEMPT QUADRATIC FIT
C
  310 ALF=AMIN+DUM*DELTA*0.5D0
      FQUAD=F5-(F3-F7)*DUM*0.125D0
      IR=7
      GO TO 10
  320 IF(.NOT.EXACT) GO TO 15
      TOL=(FNOT-FMIN)*0.025D0
      IF(TOL.LT.NOISE) TOL=NOISE
      IF(ABS(FUNC-FQUAD).LT.TOL) GO TO 15
      IF(ALF.EQ.AMIN.OR.ALF.EQ.ANEXT) GO TO 150
      GO TO 305
      END
